
// automatic differentiation: complex number support
//
// (c) 2003 Nicol N. Schraudolph, all rights reserved

#ifndef CPLX_H
#define CPLX_H

#include <cmath>
#include <complex>

// functions missing from Gnu's ANSI C++ complex type:

/* template <class T> complex<T> log10(const complex<T>& x) { */
/* #define INVLN10 0.4342944819032518276454794131646864L */
/* 	return log(x)*INVLN10; */
/* } */
/* template <class T> complex<T> tan(const complex<T>& x) { */
/* 	return sin(x)/cos(x); */
/* } */
/* template <class T> complex<T> tanh(const complex<T>& x) { */
/* 	return sinh(x)/cosh(x); */
/* } */
/* template <class T> complex<T> asin(const complex<T>& x) { */
/* 	static const complex<T> i(0,1); */
/* 	return -i*log(sqrt(1 - x*x) + i*x); */
/* } */
/* template <class T> complex<T> acos(const complex<T>& x) { */
/* 	static const complex<T> i(0,1); */
/* 	return -i*log(x + i*sqrt(1 - x*x)); */
/* } */
/* template <class T> complex<T> atan(const complex<T>& x) { */
/* 	static const complex<T> i(0,1); */
/* 	return i*log((1 - i*x)/(1 + i*x))/2; */
/* } */
/* template <class T> complex<T> asinh(const complex<T>& x) { */
/* 	return log(x + sqrt(x*x + 1)); */
/* } */
/* template <class T> complex<T> acosh(const complex<T>& x) { */
/* 	return log(x + sqrt(x*x - 1)); */
/* } */
/* template <class T> complex<T> atanh(const complex<T>& x) { */
/* 	return log((1 + x)/(1 - x))/2; */
/* } */

// leaves undefined for complex:
// expm1 log1p cbrt erf erfc j0 j1 jn y0 y1 yn

#endif  // CPLX_H

